import { APIError } from '@Models/GeneralTypes';
import {
  UserAccountInfo,
  UserOAuthUrl,
  UserSignOutUrl,
} from '@Models/Redux/User/types';

export interface GetUserSingleSignInAPIPromise extends UserOAuthUrl {
  error?: APIError;
}
export interface GetUserAccountInfoAPIPromise extends UserAccountInfo {
  error?: APIError;
}
export interface PostUserSignOutAPIPromise extends UserSignOutUrl {
  error?: APIError;
}

export interface UserAPIProps {
  getUserSSO: (backUrl: string) => Promise<GetUserSingleSignInAPIPromise>;
  getUserAccountInfo: () => Promise<GetUserAccountInfoAPIPromise>;
  postUserSignOut: () => Promise<PostUserSignOutAPIPromise>;
}
